/************************************************************************/
/*                              system.h                                */ 
/*  Configuration file for yacc.c                                       */ 
/************************************************************************/   
    
/************************************************************************/   
/*                              comments                                */ 
/*                                                                      */ 
/* This file replaces the original "files." header file. It defines,    */ 
/* for the IBM PC/XT version, the target parser function source file,   */ 
/* overriding file name string defines, and other system-specific       */ 
/* definitions and parameters.                                          */ 
/*                                                                      */ 
/************************************************************************/ 
    
/************************************************************************/   
/*                              history                                 */ 
/*                                                                      */ 
/*                                                                      */ 
/* 85Nov19 CrT	yypars.c changed to yyparse.c to avoid mismatch probs.	*/
/* 85Nov11 CrT	Cosmetics.						*/
/*									*/
/* 83Dec23 RDB  Adapt for the IBM PC/XT & DeSmet C compiler.            */ 
/*                                                                      */ 
/* 83Apr12 RDB  Add FNAMESIZE & EX_xxx parameters.                      */ 
/*                                                                      */ 
/* 81Aug28 RDB  Temp files for RSX have specific version                */ 
/*               numbers of 1 to avoid multi-versions. Rename           */ 
/*               parser info file ".i".                                 */ 
/*                                                                      */ 
/* 80Dec18 RDB  ZAPFILE no longer used in Decus Yacc.                   */ 
/*               Parser file renamed yypars.c                           */ 
/*                                                                      */
/* 7?????? SCJ  Created.                                                */
/*									*/
/*				credits 				*/
/*      CrT=CrT                                                         */  
/*      RBD=Bob Denny                                                   */  
/*      SCJ=Steven C Johnson.                                           */  
/*      SG =Scott Guthery                                               */  
/************************************************************************/ 
  
#define CrT   2001
 
/* Define WORD32 for 32-bit target machine: */

/* Target parser source file: */
#ifdef CrT
#define PARSER "\\c\\yacc\\yyparse.c"
#else
#define PARSER "yyparse.c"
#endif
 
/* basic size of the Yacc implementation: */
#define MEDIUM

/* Table size for this Yacc: */
#define MEDTAB YES

/* Filespec definitions: */
#define ACTNAME "yacc2.tmp"
#define TEMPNAME "yacc1.tmp"
#define FNAMESIZE 24

/* Exit status values: */
#define EX_SUC 1
#define EX_WAR 0
#define EX_ERR 2
#define EX_SEV 4
